merge-file: correctly open files when in a subdir
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
20
21 # Test the binaries we have just built.  The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25         # We allow tests to override this, in case they want to run tests
26         # outside of t/, e.g. for running tests on the test library
27         # itself.
28         TEST_DIRECTORY=$(pwd)
29 fi
30 if test -z "$TEST_OUTPUT_DIRECTORY"
31 then
32         # Similarly, override this to store the test-results subdir
33         # elsewhere
34         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35 fi
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
41 if test $? != 1
42 then
43         echo >&2 'error: you do not seem to have built git yet.'
44         exit 1
45 fi
46
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
49
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
53 done,*)
54         # do not redirect again
55         ;;
56 *' --tee '*|*' --va'*)
57         mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58         BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
59         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60          echo $? > $BASE.exit) | tee $BASE.out
61         test "$(cat $BASE.exit)" = 0
62         exit
63         ;;
64 esac
65
66 # For repeatability, reset the environment to known value.
67 LANG=C
68 LC_ALL=C
69 PAGER=cat
70 TZ=UTC
71 TERM=dumb
72 export LANG LC_ALL PAGER TERM TZ
73 EDITOR=:
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
76 # deriving from the command substitution clustered with the other
77 # ones.
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79         my @env = keys %ENV;
80         my $ok = join("|", qw(
81                 TRACE
82                 DEBUG
83                 USE_LOOKUP
84                 TEST
85                 .*_TEST
86                 PROVE
87                 VALGRIND
88                 UNZIP
89                 PERF_
90         ));
91         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92         print join("\n", @vars);
93 ')
94 unset XDG_CONFIG_HOME
95 unset GITPERLLIB
96 GIT_AUTHOR_EMAIL=author@example.com
97 GIT_AUTHOR_NAME='A U Thor'
98 GIT_COMMITTER_EMAIL=committer@example.com
99 GIT_COMMITTER_NAME='C O Mitter'
100 GIT_MERGE_VERBOSITY=5
101 GIT_MERGE_AUTOEDIT=no
102 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
103 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
105 export EDITOR
106
107 # Add libc MALLOC and MALLOC_PERTURB test
108 # only if we are not executing the test with valgrind
109 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
110    test -n "$TEST_NO_MALLOC_CHECK"
111 then
112         setup_malloc_check () {
113                 : nothing
114         }
115         teardown_malloc_check () {
116                 : nothing
117         }
118 else
119         setup_malloc_check () {
120                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121                 export MALLOC_CHECK_ MALLOC_PERTURB_
122         }
123         teardown_malloc_check () {
124                 unset MALLOC_CHECK_ MALLOC_PERTURB_
125         }
126 fi
127
128 # Protect ourselves from common misconfiguration to export
129 # CDPATH into the environment
130 unset CDPATH
131
132 unset GREP_OPTIONS
133 unset UNZIP
134
135 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
136 1|2|true)
137         echo "* warning: Some tests will not work if GIT_TRACE" \
138                 "is set as to trace on STDERR ! *"
139         echo "* warning: Please set GIT_TRACE to something" \
140                 "other than 1, 2 or true ! *"
141         ;;
142 esac
143
144 # Convenience
145 #
146 # A regexp to match 5 and 40 hexdigits
147 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149
150 # Zero SHA-1
151 _z40=0000000000000000000000000000000000000000
152
153 # Line feed
154 LF='
155 '
156
157 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
158 # when case-folding filenames
159 u200c=$(printf '\342\200\214')
160
161 export _x05 _x40 _z40 LF u200c
162
163 # Each test should start with something like this, after copyright notices:
164 #
165 # test_description='Description of this test...
166 # This test checks if command xyzzy does the right thing...
167 # '
168 # . ./test-lib.sh
169 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
170                 TERM=$ORIGINAL_TERM &&
171                 export TERM &&
172                 [ -t 1 ] &&
173                 tput bold >/dev/null 2>&1 &&
174                 tput setaf 1 >/dev/null 2>&1 &&
175                 tput sgr0 >/dev/null 2>&1
176         ) &&
177         color=t
178
179 while test "$#" -ne 0
180 do
181         case "$1" in
182         -d|--d|--de|--deb|--debu|--debug)
183                 debug=t; shift ;;
184         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
185                 immediate=t; shift ;;
186         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
187                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
188         -h|--h|--he|--hel|--help)
189                 help=t; shift ;;
190         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
191                 verbose=t; shift ;;
192         --verbose-only=*)
193                 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
194                 shift ;;
195         -q|--q|--qu|--qui|--quie|--quiet)
196                 # Ignore --quiet under a TAP::Harness. Saying how many tests
197                 # passed without the ok/not ok details is always an error.
198                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
199         --with-dashes)
200                 with_dashes=t; shift ;;
201         --no-color)
202                 color=; shift ;;
203         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
204                 valgrind=memcheck
205                 shift ;;
206         --valgrind=*)
207                 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
208                 shift ;;
209         --valgrind-only=*)
210                 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
211                 shift ;;
212         --tee)
213                 shift ;; # was handled already
214         --root=*)
215                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
216                 shift ;;
217         *)
218                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
219         esac
220 done
221
222 if test -n "$valgrind_only"
223 then
224         test -z "$valgrind" && valgrind=memcheck
225         test -z "$verbose" && verbose_only="$valgrind_only"
226 elif test -n "$valgrind"
227 then
228         verbose=t
229 fi
230
231 if test -n "$color"
232 then
233         say_color () {
234                 (
235                 TERM=$ORIGINAL_TERM
236                 export TERM
237                 case "$1" in
238                 error)
239                         tput bold; tput setaf 1;; # bold red
240                 skip)
241                         tput setaf 4;; # blue
242                 warn)
243                         tput setaf 3;; # brown/yellow
244                 pass)
245                         tput setaf 2;; # green
246                 info)
247                         tput setaf 6;; # cyan
248                 *)
249                         test -n "$quiet" && return;;
250                 esac
251                 shift
252                 printf "%s" "$*"
253                 tput sgr0
254                 echo
255                 )
256         }
257 else
258         say_color() {
259                 test -z "$1" && test -n "$quiet" && return
260                 shift
261                 printf "%s\n" "$*"
262         }
263 fi
264
265 error () {
266         say_color error "error: $*"
267         GIT_EXIT_OK=t
268         exit 1
269 }
270
271 say () {
272         say_color info "$*"
273 }
274
275 test "${test_description}" != "" ||
276 error "Test script did not set test_description."
277
278 if test "$help" = "t"
279 then
280         echo "$test_description"
281         exit 0
282 fi
283
284 exec 5>&1
285 exec 6<&0
286 if test "$verbose" = "t"
287 then
288         exec 4>&2 3>&1
289 else
290         exec 4>/dev/null 3>/dev/null
291 fi
292
293 test_failure=0
294 test_count=0
295 test_fixed=0
296 test_broken=0
297 test_success=0
298
299 test_external_has_tap=0
300
301 die () {
302         code=$?
303         if test -n "$GIT_EXIT_OK"
304         then
305                 exit $code
306         else
307                 echo >&5 "FATAL: Unexpected exit with code $code"
308                 exit 1
309         fi
310 }
311
312 GIT_EXIT_OK=
313 trap 'die' EXIT
314
315 # The user-facing functions are loaded from a separate file so that
316 # test_perf subshells can have them too
317 . "$TEST_DIRECTORY/test-lib-functions.sh"
318
319 # You are not expected to call test_ok_ and test_failure_ directly, use
320 # the test_expect_* functions instead.
321
322 test_ok_ () {
323         test_success=$(($test_success + 1))
324         say_color "" "ok $test_count - $@"
325 }
326
327 test_failure_ () {
328         test_failure=$(($test_failure + 1))
329         say_color error "not ok $test_count - $1"
330         shift
331         echo "$@" | sed -e 's/^/#       /'
332         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
333 }
334
335 test_known_broken_ok_ () {
336         test_fixed=$(($test_fixed+1))
337         say_color error "ok $test_count - $@ # TODO known breakage vanished"
338 }
339
340 test_known_broken_failure_ () {
341         test_broken=$(($test_broken+1))
342         say_color warn "not ok $test_count - $@ # TODO known breakage"
343 }
344
345 test_debug () {
346         test "$debug" = "" || eval "$1"
347 }
348
349 match_pattern_list () {
350         arg="$1"
351         shift
352         test -z "$*" && return 1
353         for pattern_
354         do
355                 case "$arg" in
356                 $pattern_)
357                         return 0
358                 esac
359         done
360         return 1
361 }
362
363 maybe_teardown_verbose () {
364         test -z "$verbose_only" && return
365         exec 4>/dev/null 3>/dev/null
366         verbose=
367 }
368
369 last_verbose=t
370 maybe_setup_verbose () {
371         test -z "$verbose_only" && return
372         if match_pattern_list $test_count $verbose_only
373         then
374                 exec 4>&2 3>&1
375                 # Emit a delimiting blank line when going from
376                 # non-verbose to verbose.  Within verbose mode the
377                 # delimiter is printed by test_expect_*.  The choice
378                 # of the initial $last_verbose is such that before
379                 # test 1, we do not print it.
380                 test -z "$last_verbose" && echo >&3 ""
381                 verbose=t
382         else
383                 exec 4>/dev/null 3>/dev/null
384                 verbose=
385         fi
386         last_verbose=$verbose
387 }
388
389 maybe_teardown_valgrind () {
390         test -z "$GIT_VALGRIND" && return
391         GIT_VALGRIND_ENABLED=
392 }
393
394 maybe_setup_valgrind () {
395         test -z "$GIT_VALGRIND" && return
396         if test -z "$valgrind_only"
397         then
398                 GIT_VALGRIND_ENABLED=t
399                 return
400         fi
401         GIT_VALGRIND_ENABLED=
402         if match_pattern_list $test_count $valgrind_only
403         then
404                 GIT_VALGRIND_ENABLED=t
405         fi
406 }
407
408 test_eval_ () {
409         # This is a separate function because some tests use
410         # "return" to end a test_expect_success block early.
411         eval </dev/null >&3 2>&4 "$*"
412 }
413
414 test_run_ () {
415         test_cleanup=:
416         expecting_failure=$2
417         setup_malloc_check
418         test_eval_ "$1"
419         eval_ret=$?
420         teardown_malloc_check
421
422         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
423         then
424                 setup_malloc_check
425                 test_eval_ "$test_cleanup"
426                 teardown_malloc_check
427         fi
428         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
429         then
430                 echo ""
431         fi
432         return "$eval_ret"
433 }
434
435 test_start_ () {
436         test_count=$(($test_count+1))
437         maybe_setup_verbose
438         maybe_setup_valgrind
439 }
440
441 test_finish_ () {
442         echo >&3 ""
443         maybe_teardown_valgrind
444         maybe_teardown_verbose
445 }
446
447 test_skip () {
448         to_skip=
449         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
450         then
451                 to_skip=t
452         fi
453         if test -z "$to_skip" && test -n "$test_prereq" &&
454            ! test_have_prereq "$test_prereq"
455         then
456                 to_skip=t
457         fi
458         case "$to_skip" in
459         t)
460                 of_prereq=
461                 if test "$missing_prereq" != "$test_prereq"
462                 then
463                         of_prereq=" of $test_prereq"
464                 fi
465
466                 say_color skip >&3 "skipping test: $@"
467                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
468                 : true
469                 ;;
470         *)
471                 false
472                 ;;
473         esac
474 }
475
476 # stub; perf-lib overrides it
477 test_at_end_hook_ () {
478         :
479 }
480
481 test_done () {
482         GIT_EXIT_OK=t
483
484         # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
485         # output file
486         if test -z "$HARNESS_ACTIVE"
487         then
488                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
489                 mkdir -p "$test_results_dir"
490                 base=${0##*/}
491                 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
492
493                 cat >>"$test_results_path" <<-EOF
494                 total $test_count
495                 success $test_success
496                 fixed $test_fixed
497                 broken $test_broken
498                 failed $test_failure
499
500                 EOF
501         fi
502
503         if test "$test_fixed" != 0
504         then
505                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
506         fi
507         if test "$test_broken" != 0
508         then
509                 say_color warn "# still have $test_broken known breakage(s)"
510         fi
511         if test "$test_broken" != 0 || test "$test_fixed" != 0
512         then
513                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
514                 msg="remaining $test_remaining test(s)"
515         else
516                 test_remaining=$test_count
517                 msg="$test_count test(s)"
518         fi
519         case "$test_failure" in
520         0)
521                 # Maybe print SKIP message
522                 if test -n "$skip_all" && test $test_count -gt 0
523                 then
524                         error "Can't use skip_all after running some tests"
525                 fi
526                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
527
528                 if test $test_external_has_tap -eq 0
529                 then
530                         if test $test_remaining -gt 0
531                         then
532                                 say_color pass "# passed all $msg"
533                         fi
534                         say "1..$test_count$skip_all"
535                 fi
536
537                 test -d "$remove_trash" &&
538                 cd "$(dirname "$remove_trash")" &&
539                 rm -rf "$(basename "$remove_trash")"
540
541                 test_at_end_hook_
542
543                 exit 0 ;;
544
545         *)
546                 if test $test_external_has_tap -eq 0
547                 then
548                         say_color error "# failed $test_failure among $msg"
549                         say "1..$test_count"
550                 fi
551
552                 exit 1 ;;
553
554         esac
555 }
556
557 if test -n "$valgrind"
558 then
559         make_symlink () {
560                 test -h "$2" &&
561                 test "$1" = "$(readlink "$2")" || {
562                         # be super paranoid
563                         if mkdir "$2".lock
564                         then
565                                 rm -f "$2" &&
566                                 ln -s "$1" "$2" &&
567                                 rm -r "$2".lock
568                         else
569                                 while test -d "$2".lock
570                                 do
571                                         say "Waiting for lock on $2."
572                                         sleep 1
573                                 done
574                         fi
575                 }
576         }
577
578         make_valgrind_symlink () {
579                 # handle only executables, unless they are shell libraries that
580                 # need to be in the exec-path.  We will just use "#!" as a
581                 # guess for a shell-script, since we have no idea what the user
582                 # may have configured as the shell path.
583                 test -x "$1" ||
584                 test "#!" = "$(head -c 2 <"$1")" ||
585                 return;
586
587                 base=$(basename "$1")
588                 symlink_target=$GIT_BUILD_DIR/$base
589                 # do not override scripts
590                 if test -x "$symlink_target" &&
591                     test ! -d "$symlink_target" &&
592                     test "#!" != "$(head -c 2 < "$symlink_target")"
593                 then
594                         symlink_target=../valgrind.sh
595                 fi
596                 case "$base" in
597                 *.sh|*.perl)
598                         symlink_target=../unprocessed-script
599                 esac
600                 # create the link, or replace it if it is out of date
601                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
602         }
603
604         # override all git executables in TEST_DIRECTORY/..
605         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
606         mkdir -p "$GIT_VALGRIND"/bin
607         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
608         do
609                 make_valgrind_symlink $file
610         done
611         # special-case the mergetools loadables
612         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
613         OLDIFS=$IFS
614         IFS=:
615         for path in $PATH
616         do
617                 ls "$path"/git-* 2> /dev/null |
618                 while read file
619                 do
620                         make_valgrind_symlink "$file"
621                 done
622         done
623         IFS=$OLDIFS
624         PATH=$GIT_VALGRIND/bin:$PATH
625         GIT_EXEC_PATH=$GIT_VALGRIND/bin
626         export GIT_VALGRIND
627         GIT_VALGRIND_MODE="$valgrind"
628         export GIT_VALGRIND_MODE
629         GIT_VALGRIND_ENABLED=t
630         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
631         export GIT_VALGRIND_ENABLED
632 elif test -n "$GIT_TEST_INSTALLED"
633 then
634         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
635         error "Cannot run git from $GIT_TEST_INSTALLED."
636         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
637         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
638 else # normal case, use ../bin-wrappers only unless $with_dashes:
639         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
640         if ! test -x "$git_bin_dir/git"
641         then
642                 if test -z "$with_dashes"
643                 then
644                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
645                 fi
646                 with_dashes=t
647         fi
648         PATH="$git_bin_dir:$PATH"
649         GIT_EXEC_PATH=$GIT_BUILD_DIR
650         if test -n "$with_dashes"
651         then
652                 PATH="$GIT_BUILD_DIR:$PATH"
653         fi
654 fi
655 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
656 unset GIT_CONFIG
657 GIT_CONFIG_NOSYSTEM=1
658 GIT_ATTR_NOSYSTEM=1
659 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
660
661 if test -z "$GIT_TEST_CMP"
662 then
663         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
664         then
665                 GIT_TEST_CMP="$DIFF -c"
666         else
667                 GIT_TEST_CMP="$DIFF -u"
668         fi
669 fi
670
671 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
672 export GITPERLLIB
673 test -d "$GIT_BUILD_DIR"/templates/blt || {
674         error "You haven't built things yet, have you?"
675 }
676
677 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
678 then
679         echo >&2 'You need to build test-chmtime:'
680         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
681         exit 1
682 fi
683
684 # Test repository
685 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
686 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
687 case "$TRASH_DIRECTORY" in
688 /*) ;; # absolute path is good
689  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
690 esac
691 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
692 rm -fr "$TRASH_DIRECTORY" || {
693         GIT_EXIT_OK=t
694         echo >&5 "FATAL: Cannot prepare test area"
695         exit 1
696 }
697
698 HOME="$TRASH_DIRECTORY"
699 export HOME
700
701 if test -z "$TEST_NO_CREATE_REPO"
702 then
703         test_create_repo "$TRASH_DIRECTORY"
704 else
705         mkdir -p "$TRASH_DIRECTORY"
706 fi
707 # Use -P to resolve symlinks in our working directory so that the cwd
708 # in subprocesses like git equals our $PWD (for pathname comparisons).
709 cd -P "$TRASH_DIRECTORY" || exit 1
710
711 this_test=${0##*/}
712 this_test=${this_test%%-*}
713 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
714 then
715         say_color info >&3 "skipping test $this_test altogether"
716         skip_all="skip all tests in $this_test"
717         test_done
718 fi
719
720 # Provide an implementation of the 'yes' utility
721 yes () {
722         if test $# = 0
723         then
724                 y=y
725         else
726                 y="$*"
727         fi
728
729         while echo "$y"
730         do
731                 :
732         done
733 }
734
735 # Fix some commands on Windows
736 case $(uname -s) in
737 *MINGW*)
738         # Windows has its own (incompatible) sort and find
739         sort () {
740                 /usr/bin/sort "$@"
741         }
742         find () {
743                 /usr/bin/find "$@"
744         }
745         sum () {
746                 md5sum "$@"
747         }
748         # git sees Windows-style pwd
749         pwd () {
750                 builtin pwd -W
751         }
752         # no POSIX permissions
753         # backslashes in pathspec are converted to '/'
754         # exec does not inherit the PID
755         test_set_prereq MINGW
756         test_set_prereq NOT_CYGWIN
757         test_set_prereq SED_STRIPS_CR
758         test_set_prereq GREP_STRIPS_CR
759         GIT_TEST_CMP=mingw_test_cmp
760         ;;
761 *CYGWIN*)
762         test_set_prereq POSIXPERM
763         test_set_prereq EXECKEEPSPID
764         test_set_prereq NOT_MINGW
765         test_set_prereq CYGWIN
766         test_set_prereq SED_STRIPS_CR
767         test_set_prereq GREP_STRIPS_CR
768         ;;
769 *)
770         test_set_prereq POSIXPERM
771         test_set_prereq BSLASHPSPEC
772         test_set_prereq EXECKEEPSPID
773         test_set_prereq NOT_MINGW
774         test_set_prereq NOT_CYGWIN
775         ;;
776 esac
777
778 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
779 test -z "$NO_PERL" && test_set_prereq PERL
780 test -z "$NO_PYTHON" && test_set_prereq PYTHON
781 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
782 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
783
784 # Can we rely on git's output in the C locale?
785 if test -n "$GETTEXT_POISON"
786 then
787         GIT_GETTEXT_POISON=YesPlease
788         export GIT_GETTEXT_POISON
789         test_set_prereq GETTEXT_POISON
790 else
791         test_set_prereq C_LOCALE_OUTPUT
792 fi
793
794 # Use this instead of test_cmp to compare files that contain expected and
795 # actual output from git commands that can be translated.  When running
796 # under GETTEXT_POISON this pretends that the command produced expected
797 # results.
798 test_i18ncmp () {
799         test -n "$GETTEXT_POISON" || test_cmp "$@"
800 }
801
802 # Use this instead of "grep expected-string actual" to see if the
803 # output from a git command that can be translated either contains an
804 # expected string, or does not contain an unwanted one.  When running
805 # under GETTEXT_POISON this pretends that the command produced expected
806 # results.
807 test_i18ngrep () {
808         if test -n "$GETTEXT_POISON"
809         then
810             : # pretend success
811         elif test "x!" = "x$1"
812         then
813                 shift
814                 ! grep "$@"
815         else
816                 grep "$@"
817         fi
818 }
819
820 test_lazy_prereq PIPE '
821         # test whether the filesystem supports FIFOs
822         case $(uname -s) in
823         CYGWIN*)
824                 false
825                 ;;
826         *)
827                 rm -f testfifo && mkfifo testfifo
828                 ;;
829         esac
830 '
831
832 test_lazy_prereq SYMLINKS '
833         # test whether the filesystem supports symbolic links
834         ln -s x y && test -h y
835 '
836
837 test_lazy_prereq CASE_INSENSITIVE_FS '
838         echo good >CamelCase &&
839         echo bad >camelcase &&
840         test "$(cat CamelCase)" != good
841 '
842
843 test_lazy_prereq UTF8_NFD_TO_NFC '
844         # check whether FS converts nfd unicode to nfc
845         auml=$(printf "\303\244")
846         aumlcdiar=$(printf "\141\314\210")
847         >"$auml" &&
848         case "$(echo *)" in
849         "$aumlcdiar")
850                 true ;;
851         *)
852                 false ;;
853         esac
854 '
855
856 test_lazy_prereq AUTOIDENT '
857         sane_unset GIT_AUTHOR_NAME &&
858         sane_unset GIT_AUTHOR_EMAIL &&
859         git var GIT_AUTHOR_IDENT
860 '
861
862 # When the tests are run as root, permission tests will report that
863 # things are writable when they shouldn't be.
864 test -w / || test_set_prereq SANITY
865
866 GIT_UNZIP=${GIT_UNZIP:-unzip}
867 test_lazy_prereq UNZIP '
868         "$GIT_UNZIP" -v
869         test $? -ne 127
870 '